# Scola version 1.1.0
# ScolaProcesses.py
# by Antoine Rauzy
# Copyrights (c) 2018 AltaRica Association
#
# This file is part of ScolaWizard.
# ScolaWizard is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# ScolaWizard is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with ScolaWizard.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Processes

# 1) Imported modules
# -------------------

import sys
import os

from ScolaConstants import *
from ScolaModels import *

# 2) Processes
# ------------

class ScolaProcess:
  def __init__(self, number, location):
    self._number = number
    self._location = location
    self._active = False
    self._parent = None
    self._children = []
    self._origin = None

  def GetNumber(self):
    return self._number

  def GetLocation(self):
    return self._location
  def SetLocation(self, location):
    self._location = location

  def IsActive(self):
    return self._active
  def SetActive(self, value):
    self._active = value

  def GetParent(self):
    return self._parent
  def GetNumberOfChildren(self):
    return len(self._children)
  def GetChild(self, index):
    if index<0 or index>=self.GetNumberOfChildren():
      return None
    return self._children[index]
  def GetChildren(self):
    return self._children
  def AddChild(self, child):
    self._children.append(child)
    child._parent = self
  def RemoveChild(self, child):
    if child._parent!=self:
      return
    self._children.remove(child)
    child._parent = None

  def GetOrigin(self):
    return self._origin
  def SetOrigin(self, origin):
    self._origin = origin

